/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_EchocardiographyCommonMeasurements;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_EchocardiographyPulmonaryArtery;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_EchocardiographyPulmonaryArtery;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;
import cdac.medinfo.sdk.dcm30_04.utils.ResourceBundleWrapper;

import java.util.Locale;

import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumChestCardiacSNOMEDMap;

/**
 * This class represents EchocardiographyPulmonaryArtery CID12210
 */
public class EchocardiographyPulmonaryArtery_CID12210 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;
	/**
	 * Object of EchocardiographyCommonMeasurements_CID12220
	 */
	private EchocardiographyCommonMeasurements_CID12220 objEchocardiographyCommonMeasurementsCID12220;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new EchocardiographyPulmonaryArtery_CID12210 Template 
	 */
	public EchocardiographyPulmonaryArtery_CID12210()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumEchocardiographyPulmonaryArtery Object of EnumCM_EchocardiographyPulmonaryArtery represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_EchocardiographyPulmonaryArtery enumEchocardiographyPulmonaryArtery)
	{
		switch(enumEchocardiographyPulmonaryArtery) 
		{
		case MAIN_PULMONARY_ARTERY_DIAMETER: this.strCodeValue =EnumCV_EchocardiographyPulmonaryArtery.MAIN_PULMONARY_ARTERY_DIAMETER_18020_8.getValue(); break;
		case RIGHT_PULMONARY_ARTERY_DIAMETER: this.strCodeValue =EnumCV_EchocardiographyPulmonaryArtery.RIGHT_PULMONARY_ARTERY_DIAMETER_18021_6.getValue(); break;
		case LEFT_PULMONARY_ARTERY_DIAMETER: this.strCodeValue =EnumCV_EchocardiographyPulmonaryArtery.LEFT_PULMONARY_ARTERY_DIAMETER_18019_0.getValue(); break;
		case MAIN_PULMONARY_ARTERY_PEAK_VELOCITY: this.strCodeValue =EnumCV_EchocardiographyPulmonaryArtery.MAIN_PULMONARY_ARTERY_PEAK_VELOCITY_G_038A.getValue(); break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumEchocardiographyPulmonaryArtery Object of EnumCM_EchocardiographyPulmonaryArtery represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_EchocardiographyPulmonaryArtery enumEchocardiographyPulmonaryArtery)
	{
		switch(enumEchocardiographyPulmonaryArtery)
		{
		case MAIN_PULMONARY_ARTERY_PEAK_VELOCITY : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.MAIN_PULMONARY_ARTERY_PEAK_VELOCITY.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for EchocardiographyPulmonaryArtery
	 * @param enumEchocardiographyPulmonaryArtery Object of EnumCM_EchocardiographyPulmonaryArtery.
	 */
	public void setEchocardiographyPulmonaryArtery(Enum enumValue)
	{
		if(enumValue instanceof EnumCM_EchocardiographyPulmonaryArtery)
		{
			 /**
				 * Casting EnumValue to required Enum.
				 */
			EnumCM_EchocardiographyPulmonaryArtery new_enumEchocardiographyPulmonaryArtery = (EnumCM_EchocardiographyPulmonaryArtery)enumValue;
				
				this.strCodeMeaning = new_enumEchocardiographyPulmonaryArtery.getValue();
				if(new_enumEchocardiographyPulmonaryArtery.getValue().equalsIgnoreCase(EnumCM_EchocardiographyPulmonaryArtery.MAIN_PULMONARY_ARTERY_PEAK_VELOCITY.getValue()))
				{
					this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
				}
				else
				{
					this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.LN.getValue();
				}
				
				/**
				 * set code Value
				 */
				setCodeValue(new_enumEchocardiographyPulmonaryArtery);
				/**
				 * set SNOMED-CT ID
				 */
				setSNOMEDCTID(new_enumEchocardiographyPulmonaryArtery);

		}
		 else if(enumValue instanceof EnumCM_EchocardiographyCommonMeasurements)
			{
				/**
				 * Casting EnumValue to required Enum.
				 */
			 EnumCM_EchocardiographyCommonMeasurements new_enumEchocardiographyCommonMeasurements = (EnumCM_EchocardiographyCommonMeasurements) enumValue;
				
				/**
				 * Creating object of require CID with respect to enum and setting value accordingly.
				 */
				if(null== this.objEchocardiographyCommonMeasurementsCID12220)
				this.objEchocardiographyCommonMeasurementsCID12220 = new EchocardiographyCommonMeasurements_CID12220();
				this.objEchocardiographyCommonMeasurementsCID12220.setEchocardiographyCommonMeasurements(new_enumEchocardiographyCommonMeasurements);
				
				/**
				 * Retrieving attributes and setting it to member variables. 
				 */
				this.strCodeMeaning = objEchocardiographyCommonMeasurementsCID12220.getCodeMeaning();
				this.strCodeValue = objEchocardiographyCommonMeasurementsCID12220.getCodeValue();
				this.strCodingSchemeDesignator = objEchocardiographyCommonMeasurementsCID12220.getCodingSchemeDesignator();
			}		 
		else
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger objDicomLogger = DicomLogger.getLogger();
				objDicomLogger.log(ResourceBundleWrapper.getValue("warning","InvalidEnumeratedValue",new Locale(DicomConfig.createInstance().getLocale())));
			}
		}
	}
}
